



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>强化学习（五）—— 策略梯度及reinforce算法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">强化学习（五）—— 策略梯度及reinforce算法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 13:08:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1 概述</strong></p>
<p>　　在该系列上一篇中介绍的基于价值的深度强化学习方法有它自身的缺点，主要有以下三点：</p>
<p>　　1）基于价值的强化学习无法很好的处理连续空间的动作问题，或者时高维度的离散动作空间，因为通过价值更新策略时是需要对每个动作下的价值函数的大小进行比较的，因此在高维或连续的动作空间下是很难处理的。</p>
<p>　　2）在基于价值的强化学习中我们用特征来描述状态空间中的某一状态时，有可能因为个体观测的限制或者建模的局限，导致真实环境下本来不同的两个状态却再我们建模后拥有相同的特征描述，进而很有可能导致我们的value Based方法无法得到最优解。如下图：</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1335117/201902/1335117-20190220153207606-999000192.png" /></p>
<p>　　　　当有些个体选择比较容易观测的特征来描述状态空间时，比如颜色，则在上图中两个灰色格子（代表着两个不同的状态）的特征表示是一样的，倘若我们的最终目的是要获得金币，则当你在左边的灰色格子时，你需要往右移；当你在右边的灰色格子时，你需要往左移。而在基于价值的强化学习方法中，策略往往时确定的，也就是你的状态确定了，动作就确定了，那么在这里如果两个灰色格子的状态是一样，则执行的动作是一样的。这显然是不行的。</p>
<p>　　3）无法解决随机策略问题，基于价值的强化学习的策略是确定的（当然也可以用$\epsilon-greedy$，但是随机性没那么强），而基于策略的强化学习是具有随机性的。</p>
<p><strong>2 策略梯度</strong></p>
<p>　　首先来从似然率的角度推到策略梯度：</p>
<p>　　给定一组状态-动作序列$\tau = s_0, a_0, s_1, a_1, ......, s_l, a_l。</p>
<p>　　则有$R(\tau) = \sum_{t=0}^l R(s_t, a_t)$表示序列$\tau$的回报。$P(\tau; \theta)$表示序列$\tau$出现的概率，则策略梯度的目标函数可以表示为：</p>
<p>　　　　$J(\theta) = E(\sum_{t=0}^l R(s_t, a_t); \pi_{\theta}) = \sum_{\tau} P(\tau; \theta)R(\tau)$</p>
<p>　　策略梯度的目标就是找到最优参数$\theta$，使得$J(\theta)$最大。因此策略梯度是一个优化问题，最简单的就是用梯度上升法来求解：</p>
<p>　　　　$\theta = \theta + \alpha \nabla_{\theta}J(\theta)$</p>
<p>　　现在我们来对目标函数求导：</p>
<p>　　　　$&nbsp;\nabla_{\theta}J(\theta) = &nbsp;\nabla_{\theta}\sum_{\tau} P(\tau; \theta)R(\tau)$</p>
<p>　　　　$=\sum_{\tau} \nabla_{\theta}P(\tau; \theta)R(\tau)$</p>
<p>　　　　$=\sum_{\tau} \frac{P(\tau; \theta)}{P(\tau; \theta)} \nabla_{\theta}P(\tau; \theta)R(\tau)$</p>
<p>　　　　$=\sum_{\tau} P(\tau; \theta)\frac{\nabla_{\theta}P(\tau; \theta)R(\tau)}{P(\tau; \theta)}$</p>
<p>　　　　$=\sum_{\tau} P(\tau; \theta) \nabla_{\theta} \log{P(\tau; \theta)}R(\tau)$</p>
<p>　　因此最终的策略梯度就变成求$&nbsp;\nabla_{\theta} \log{P(\tau; \theta)}R(\tau)$的期望了，这样当采样$m$条样本序列时，就可以利用$m$条序列的均值逼近策略梯度的期望：</p>
<p>　　　　$&nbsp;\nabla_{\theta}J(\theta) = \frac{1}{m} \sum_{i=1}^m \nabla_{\theta} \log{P(\tau; \theta)}R(\tau)$</p>
<p>　　从上面的式子可以看出第一项$\nabla_{\theta} \log{P(\tau; \theta)}$是轨迹$\tau$ 的概率随参数$\theta$变化最陡的方向。第二项$R(\tau)$控制了参数更新的方向和步长。</p>
<p>　　对于每一条序列$\tau$的概率$P(\tau; \theta)$都可以表示成下面的形式：</p>
<p>　　　　$P(\tau^i; \theta) = \prod_{t=0}^l P(s_{t+1}^i | s_t^i, a_t^i) \pi_{\theta}(a_t^i | s_t^i)$</p>
<p>　　对上面的式子代入到梯度的式子中，通过对数展开可以得到：</p>
<p>　　　　$&nbsp;\nabla_{\theta}J(\theta) = \frac{1}{m} \sum_{i=1}^m (\sum_{t=0}^l \nabla_{\theta} \log{\pi_{\theta} (a_t^i | s_t^i)}R(\tau^i))$</p>
<p>　　但是上面的式子有一个问题，就是后面的$R(\tau^i)$是对整条序列的回报，但是在$t$时刻的策略对应的回报不应该和$t$时刻之前的状态-动作价值无关。因此对这个式子进行修改可以得到：</p>
<p>　　　　$\nabla_{\theta} J(\theta) = \mathbb{E}_{\pi_{\theta}}[\nabla_{\theta}log&nbsp;\pi_{\theta}(s,a) Q_{\pi}(s,a)]$</p>
<p>　　在上面的式子中$\nabla_{\theta}log&nbsp;\pi_{\theta}(s,a)$ 是不会改变的，这个一般称为分值函数，但后面的$Q_{\pi}(s,a)$是可能发生改变的。</p>
<p>　　除了这个问题之外，还有一个问题就是策略梯度$\nabla_{\theta}J(\theta)$的方差很大，这个时候一般引入一个常数基线b，即：</p>
<p>　　　　$\nabla_{\theta} J(\theta) = \mathbb{E}_{\pi_{\theta}}[\nabla_{\theta}log&nbsp;\pi_{\theta}(s,a) (Q_{\pi}(s,a) - b)]$</p>
<p>　　这个常数的引入不会影响到梯度的值（证明忽略），但是在某一个b值下可以使得梯度的方差最小。</p>
<p><strong>3 策略函数</strong></p>
<p>　　我们上面抽象的用一个函数表示了策略函数，那策略函数的具体形式是什么样子的呢？一般来说，对于离散的动作空间，用softmax函数来描述；对于连续的动作空间，用高斯函数来描述。</p>
<p>　　在离散的动作空间中，softmax函数描述了各个动作被选中的概率，在构建网络时可以当作是一个多分类的问题：</p>
<p>　　　　$\pi_{\theta}(s,a) = \frac{e^{\phi(s,a)^T\theta}}{\sum\limits_be^{\phi(s,b)^T\theta}}$</p>
<p>　　其中$\phi(s,a)$表示的是给定状态s，动作a的特征表示。</p>
<p>　　在连续的动作空间中，策略产生动作是遵循高斯分布$\mathbb{N(\phi(s)^T\theta, \sigma^2)}%$的。</p>
<p><strong>4 reinforce算法流程</strong></p>
<p>　　在蒙特卡洛策略梯度reinforce算法，我们用价值函数$v(s)$近似的替代上面的目标函数中的$Q(s, a)$。则整个流程如下：</p>
<p>　　假设迭代轮数为EPISODES，采样的序列最大长度为L，学习速率为$\alpha$，状态集为S，动作集为A。</p>
<p>　　1）for episode in range(EPISODES):&nbsp; &nbsp;# 开始迭代</p>
<p>　　2）初始化状态s，在这里s为状态向量</p>
<p>　　3）for step in range(T):&nbsp; # 序列采样</p>
<p>　　　　a) 将状态向量s输入到策略函数中，我们可以得到softmax之后每个动作的概率，根据概率去选择动作（<strong>增加了随机性，而不是每次选择概率最大的动作</strong>）；</p>
<p>　　　　b) 在状态s下执行当前动作$a$，获得下一状态$s&lsquo;$，当前奖励$R$，是否终止状态${is\_end}$；</p>
<p>　　　　c) 将当前的状态$s$，动作$a$，奖励$R$分别存储在一个列表中；</p>
<p>　　　　d) 更新状态，$s = s'$；</p>
<p>　　　　e) 判断是否是最终状态，如果是则将这条采样得到的序列用来更新策略函数中的参数；否则继续循环采样。</p>
<p>　　　　　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvj46jq.html">C&num; 加密&ndash;RSA前端与后台的加密&amp;amp&semi;解密</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71zpkq.html">AJAX 后台返回多种数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwmxgk8.html">matlab使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1er4d9.html">c&num;自带压缩类实现数据库表导出到CSV压缩文件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xz7n9.html">Linq-表达式常用写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdevnex9.html">自构BeanHandler&lpar;用BeansUtils&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yvmyz8.html">搭建vue开发环境及各种报错处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17vy1q.html">SQL Server插入数据和删除数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pgnp48.html">Activity的setContentView的流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1l6kdq.html">MFC下用sdl 显示bmp、rgb、yuv</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me6yvrq.html">JFinal项目发送邮件&mdash;&mdash;jfinal-mail-plugin</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzodpe8.html">&period;net相关知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/9505wke8.html">Gym 101606 - A&sol;B&sol;C&sol;D&sol;E&sol;F&sol;G&sol;H&sol;I&sol;J&sol;K&sol;L - &lpar;Undone&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyn5639.html">论文笔记之：Learning Cross-Modal Deep Representations for Robust Pedestrian Detection</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyz50d9.html">window有哪些属性？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppkk2z9.html">论文笔记：语音情感识别（三）手工特征&plus;CRNN</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn5pwkq.html">PHP接口开发加密技术实例原理与例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnldoxq.html">Javascript&sol;jQuery关于JSON或数组集合的几种循环方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4weppq.html">&lbrack;Jobdu&rsqb; 题目1214：丑数</a>
		</li>
						<li><a href="https://www.batexi.com/a/902gwg3q.html">Linux单用户CS模型TCP通讯完全注释手册</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rg237e8.html">Win7系统修改hosts无法保存怎么办？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk3r3e8.html">Error&colon;&amp;quot&semi;MetaStoreClient lost connection&period; Attempting to reconnect &lpar;1 of 24&rpar; after 5s&period; getCurrentNotificationEventId&amp;quot&semi; occurs as HiveServer2 fails to start as it cannot connect to Metastore in HDP 3&period;0</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzor348.html">canvas百分比加载动画</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk3grd8.html">oracle 一些常用的sql优化规则</a>
			</li>
						<li><a href="https://www.batexi.com/a/96prnwy8.html">chrome谷歌开发者工具（hover时候的css样式怎么在浏览器调试）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjgg0r8.html">我眼中的 Nginx（一）：Nginx 和位运算</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjxxeg8.html">qml demo分析&lpar;objectlistmodel-自定义qml数据&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y4enn8.html">从PRISM开始学WPF（四）Prism-Module-更新至Prism7&period;1</a>
			</li>
						<li><a href="https://www.batexi.com/a/950e65m8.html">LINQ之道</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd41x49.html">WinForm的EXE破解&lpar;基于IL修改）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
